<?php

namespace STM\Match;

use STM\Competition\Season\Season;
use \Exception;
use STM\StmFactory;

/**
 * Test class for Match.
 * Generated by PHPUnit on 2011-08-22 at 16:00:58.
 * @group match
 */
class MatchTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $all_matches;
    private $played_matches;
    private $upcoming_matches;

    protected function setUp() {
        $this->bad_values = array(null, false, array(), new Exception());
        $this->allMatches = getMatches(MatchSelection::ALL_MATCHES, true, true);
        $this->playedMatches = getMatches(MatchSelection::PLAYED_MATCHES, true, true);
        $this->upcoming_matches = getMatches(MatchSelection::UPCOMING_MATCHES, true, true);
    }

    protected function tearDown() {}

    public function testfindById() {
        foreach ($this->bad_values as $value) {
            $this->assertFalse(StmFactory::find()->Match->findById ($value));
        }
        foreach ($this->allMatches as $match) {
            $this->assertFalse(StmFactory::find()->Match->findById ($match));            
            parent::assertInstanceOf('\STM\Match\Match', StmFactory::find()->Match->findById ($match->getId()));
        }        
    }
 
    public function testDeleteMatches() {
        foreach ($this->bad_values as $value) {
            $this->assertFalse(Match::deleteMatches($value));
        }
    }    

    public function testCreate() {
        $this->markTestSkipped('in MatchValidatorTest');
    }

    public function testDelete() {
        $this->markTestSkipped('Delete can fail only in database');
    }

    public function testUpdate() {
        $this->markTestSkipped('in MatchValidatorTest');
    }  

    public function testHas_periods() {        
        foreach ($this->playedMatches as $played_match) {
            $this->assertTrue($played_match->hasPeriods());
        }
        foreach ($this->upcoming_matches as $upcoming_match) {
            $this->assertFalse($upcoming_match->hasPeriods());
        }
    }

    public function testHas_loaded_periods() {
        foreach (getMatches(MatchSelection::PLAYED_MATCHES, true, false) as $match) {
            $this->assertFalse($match->hasLoadedPeriods());
            $this->assertTrue($match->hasPeriods());
        }        
    }

    public function testGet_periods() {
        foreach (getMatches(MatchSelection::ALL_MATCHES, true, false) as $match) {
            $this->assertFalse($match->getPeriods());
        }
        foreach ($this->playedMatches as $played_match) {
            foreach($played_match->getPeriods() as $period) {
                parent::assertInstanceOf('\STM\Match\Period\Period', $period);
            }            
        }
    }

    public function testGet_id() {
        foreach ($this->allMatches as $match) {
            $this->assertTrue(is_int($match->getId()));
        }
    }

    public function testGet_score_home() {
        foreach ($this->playedMatches as $played_match) {
            $this->assertTrue(is_int($played_match->getScoreHome()));
        }
        foreach ($this->upcoming_matches as $upcoming_match) {
            $this->assertFalse($upcoming_match->getScoreHome());
        }
    }

    public function testGet_score_away() {
        foreach ($this->playedMatches as $played_match) {
            $this->assertTrue(is_int($played_match->getScoreAway()));
        }
        foreach ($this->upcoming_matches as $upcoming_match) {
            $this->assertFalse($upcoming_match->getScoreAway());
        }
    }

    public function testGet_competition_id() {
        foreach($this->allMatches as $match) {
            $this->assertTrue(is_int($match->getIdCompetition()));
        }
    }
    
    public function testGet_team_home_id() {
        foreach($this->allMatches as $match) {
            $this->assertTrue(is_int($match->getIdTeamHome()));
        }
    }   
    
    public function testGet_team_away_id() {
        foreach($this->allMatches as $match) {
            $this->assertTrue(is_int($match->getIdTeamAway()));
        }
    }      
    
    public function testGet_round() {
        foreach($this->allMatches as $match) {
            $competition = StmFactory::find()->Competition->findById($match->getIdCompetition());            
            if ($competition instanceof Season) {
                $this->assertTrue(is_int($match->getRound()));
            } else {
                $this->assertFalse($match->getRound());
            }
        }
    }          
    
    public function testTo_array() {
        foreach ($this->allMatches as $match) {
            $array = $match->toArray();
            $this->assertArrayHasKey('date', $array);
            $this->assertArrayHasKey('team_home', $array);
            $this->assertArrayHasKey('team_away', $array);
            $this->assertArrayHasKey('score_home', $array);            
            $this->assertArrayHasKey('score_away', $array);
        }
    }

    public function test__toString() {
        foreach ($this->allMatches as $match) {
            $this->assertTrue(is_string($match->__toString()));
        }
    }

}

?>
